/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBGL)

#include "JSWebGLVertexArrayObject.h"

#include "JSDOMBinding.h"
#include "WebGLVertexArrayObject.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsWebGLVertexArrayObjectConstructor(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSWebGLVertexArrayObjectPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSWebGLVertexArrayObjectPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebGLVertexArrayObjectPrototype* ptr = new (NotNull, JSC::allocateCell<JSWebGLVertexArrayObjectPrototype>(vm.heap)) JSWebGLVertexArrayObjectPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebGLVertexArrayObjectPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

class JSWebGLVertexArrayObjectConstructor : public DOMConstructorObject {
private:
    JSWebGLVertexArrayObjectConstructor(JSC::Structure*, JSDOMGlobalObject*);
    void finishCreation(JSC::VM&, JSDOMGlobalObject*);

public:
    typedef DOMConstructorObject Base;
    static JSWebGLVertexArrayObjectConstructor* create(JSC::VM& vm, JSC::Structure* structure, JSDOMGlobalObject* globalObject)
    {
        JSWebGLVertexArrayObjectConstructor* ptr = new (NotNull, JSC::allocateCell<JSWebGLVertexArrayObjectConstructor>(vm.heap)) JSWebGLVertexArrayObjectConstructor(structure, globalObject);
        ptr->finishCreation(vm, globalObject);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }
};

const ClassInfo JSWebGLVertexArrayObjectConstructor::s_info = { "WebGLVertexArrayObjectConstructor", &Base::s_info, 0, CREATE_METHOD_TABLE(JSWebGLVertexArrayObjectConstructor) };

JSWebGLVertexArrayObjectConstructor::JSWebGLVertexArrayObjectConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSWebGLVertexArrayObjectConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSWebGLVertexArrayObject::getPrototype(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

/* Hash table for prototype */

static const HashTableValue JSWebGLVertexArrayObjectPrototypeTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebGLVertexArrayObjectConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

WEBCORE_EXPORT const ClassInfo JSWebGLVertexArrayObjectPrototype::s_info = { "WebGLVertexArrayObjectPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSWebGLVertexArrayObjectPrototype) };

void JSWebGLVertexArrayObjectPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebGLVertexArrayObjectPrototypeTableValues, *this);
}

WEBCORE_EXPORT const ClassInfo JSWebGLVertexArrayObject::s_info = { "WebGLVertexArrayObject", &Base::s_info, 0, CREATE_METHOD_TABLE(JSWebGLVertexArrayObject) };

JSWebGLVertexArrayObject::JSWebGLVertexArrayObject(Structure* structure, JSDOMGlobalObject* globalObject, Ref<WebGLVertexArrayObject>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSWebGLVertexArrayObject::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSWebGLVertexArrayObjectPrototype::create(vm, globalObject, JSWebGLVertexArrayObjectPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSWebGLVertexArrayObject::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSWebGLVertexArrayObject>(vm, globalObject);
}

void JSWebGLVertexArrayObject::destroy(JSC::JSCell* cell)
{
    JSWebGLVertexArrayObject* thisObject = static_cast<JSWebGLVertexArrayObject*>(cell);
    thisObject->JSWebGLVertexArrayObject::~JSWebGLVertexArrayObject();
}

JSWebGLVertexArrayObject::~JSWebGLVertexArrayObject()
{
    releaseImplIfNotNull();
}

EncodedJSValue jsWebGLVertexArrayObjectConstructor(ExecState* exec, JSObject* baseValue, EncodedJSValue, PropertyName)
{
    JSWebGLVertexArrayObjectPrototype* domObject = jsDynamicCast<JSWebGLVertexArrayObjectPrototype*>(baseValue);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSWebGLVertexArrayObject::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSWebGLVertexArrayObject::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebGLVertexArrayObjectConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

bool JSWebGLVertexArrayObjectOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSWebGLVertexArrayObjectOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSWebGLVertexArrayObject* jsWebGLVertexArrayObject = jsCast<JSWebGLVertexArrayObject*>(handle.slot()->asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsWebGLVertexArrayObject->impl(), jsWebGLVertexArrayObject);
    jsWebGLVertexArrayObject->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7WebGLVertexArrayObject@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore22WebGLVertexArrayObjectE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, WebGLVertexArrayObject* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSWebGLVertexArrayObject>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7WebGLVertexArrayObject@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore22WebGLVertexArrayObjectE[2];
#if COMPILER(CLANG)
    // If this fails WebGLVertexArrayObject does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(WebGLVertexArrayObject), WebGLVertexArrayObject_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // WebGLVertexArrayObject has subclasses. If WebGLVertexArrayObject has subclasses that get passed
    // to toJS() we currently require WebGLVertexArrayObject you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSWebGLVertexArrayObject>(globalObject, impl);
}

WebGLVertexArrayObject* JSWebGLVertexArrayObject::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSWebGLVertexArrayObject*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(WEBGL)
